<script setup>
import { darkTheme, dateZhTW, lightTheme, zhTW } from 'naive-ui'
import themeOverrides from '~/styles/naive-ui-theme-overrides.json'

useHead({
  title: 'Naive UI example',
})

const selectOptions = [
  { label: 'label1', value: 'value1', key: 'key1', labelX: 'labelX1' },
  { label: 'label2', value: 'value2', key: 'key2', labelX: 'labelX2' },
]
const cascaderOptions = [
  {
    label: 'label1',
    value: 'value1',
    children: [{ label: 'label2', value: 'value2' }],
  },
]
const treeOptions = [
  {
    label: 'label1',
    key: 'key1',
    children: [{ label: 'label2', key: 'key2' }],
  },
]
const isDark = useDark()
const theme = computed(() => (isDark.value ? darkTheme : lightTheme))
const showModal = ref(false)
const showDrawer = ref(false)
const showCollapseTransition = ref(true)
</script>

<template>
  <div class="relative dark:bg-dark dark:color-light">
    <div class="sticky left-0 right-0 top-0 z-100 flex items-center gap-4 bg-light p-2 shadow dark:bg-dark dark:color-light">
      <RouterLink class="absolute flex items-center gap-2 rounded bg-green/25 p-2 transition hover:bg-green/50" to="/examples">
        <i class="i-carbon-arrow-left"></i>
        Back
      </RouterLink>
      <h2 class="flex-grow py-2 text-center text-2xl">
        Naive UI
      </h2>
      <NSwitch v-model:value="isDark">
        <template #checked>
          深色主題
        </template>
        <template #unchecked>
          亮色主題
        </template>
      </NSwitch>
    </div>
    <NConfigProvider :theme="theme" :locale="zhTW" :date-locale="dateZhTW" :theme-overrides="themeOverrides" inline-theme-disabled>
      <NMessageProvider>
        <NNotificationProvider>
          <NLoadingBarProvider>
            <NDialogProvider>
              <NSpace class="px-2" vertical>
                <h3>Button</h3>
                <NButton>Button</NButton>
                <h3>Button Group</h3>
                <NButtonGroup>
                  <NButton>Button Group</NButton>
                </NButtonGroup>
                <h3>Input</h3>
                <NInput placeholder="NInput" />
                <h3>Dynamic Input</h3>
                <NDynamicInput />
                <h3>Input Number</h3>
                <NInputNumber placeholder="NInputNumber" />
                <h3>Select</h3>
                <NSelect placeholder="NSelect" :options="selectOptions" />
                <h3>Auto Complete</h3>
                <NAutoComplete
                  placeholder="NAutoComplete"
                  :options="selectOptions"
                />
                <h3>Cascader</h3>
                <NCascader placeholder="NCascader" :options="cascaderOptions" />
                <h3>Mention</h3>
                <NMention placeholder="NMention" :options="selectOptions" />
                <h3>Popover</h3>
                <NPopover>
                  <template #trigger>
                    <NButton>NPopover</NButton>
                  </template>
                  Popover Content
                </NPopover>
                <h3>Popover Confirm</h3>
                <NPopconfirm>
                  <template #trigger>
                    <NButton>NPopconfirm</NButton>
                  </template>
                </NPopconfirm>
                <h3>Popover Select</h3>
                <NPopselect :options="selectOptions">
                  <NButton>NPopselect</NButton>
                </NPopselect>
                <h3>Dropdown</h3>
                <NDropdown :options="treeOptions">
                  <NButton>Dropdown</NButton>
                </NDropdown>
                <h3>Tree Select</h3>
                <NTreeSelect :options="treeOptions" />
                <h3>Tooltip</h3>
                <NTooltip>
                  <template #trigger>
                    <NButton>Tooltip</NButton>
                  </template>
                  Toooltip
                </NTooltip>
                <h3>Tree</h3>
                <NTree :data="treeOptions" />
                <h3>Time Picker</h3>
                <NTimePicker />
                <h3>Date Picker</h3>
                <NDatePicker />
                <h3>Color Picker</h3>
                <NColorPicker />
                <h3>Switch</h3>
                <NSwitch />
                <h3>Slider</h3>
                <NSlider />
                <h3>Checkbox</h3>
                <NCheckbox label="Checkbox" />
                <h3>Checkbox NRadioGroup2</h3>
                <NCheckboxGroup>
                  <NSpace>
                    <NCheckbox label="CheckboxGroup1" value="foo" />
                    <NCheckbox label="CheckboxGroup2" value="bar" />
                  </NSpace>
                </NCheckboxGroup>
                <h3>Calendar</h3>
                <NCalendar />
                <h3>Divider</h3>
                <NDivider />
                <h3>Empty</h3>
                <NEmpty />
                <h3>Gradient Text</h3>
                <NGradientText :size="24" type="info">
                  NGradientText
                </NGradientText>
                <h3>Tag</h3>
                <NTag>NTag</NTag>
                <h3>Dynamic Tags</h3>
                <NDynamicTags />
                <h3>Text</h3>
                <NText>NText</NText>
                <h3>Badge</h3>
                <NBadge :value="999">
                  NBadge
                </NBadge>
                <h3>Breadcrumb</h3>
                <NBreadcrumb>
                  <NBreadcrumbItem>NBreadcrumbItem1</NBreadcrumbItem>
                  <NBreadcrumbItem>NBreadcrumbItem2</NBreadcrumbItem>
                </NBreadcrumb>
                <h3>Blockquote</h3>
                <NBlockquote>NBlockquote</NBlockquote>
                <h3>Ellipsis</h3>
                <NEllipsis
                  style="max-width: 80px;"
                  :tooltip="{ arrowPointToCenter: true }"
                >
                  NEllipsis.....................
                </NEllipsis>
                <h3>Progress</h3>
                <NProgress type="circle" :percentage="50" />
                <h3>Rate</h3>
                <NRate />
                <h3>Page Header</h3>
                <NPageHeader subtitle="PageHeader Subtitle">
                  <template #title>
                    PageHeader
                  </template>
                </NPageHeader>
                <h3>Spin</h3>
                <NSpin />
                <h3>Pagination</h3>
                <NPagination :page-count="100" />
                <h3>Menu</h3>
                <NMenu :options="treeOptions" />
                <h3>Alert</h3>
                <NAlert title="NAlert" type="info">
                  NAlert
                </NAlert>
                <h3>Result</h3>
                <NResult status="404" />
                <h3>List</h3>
                <NList>
                  <NListItem>ListItem</NListItem>
                </NList>
                <h3>Time</h3>
                <NTime :time="0" type="date" />
                <h3>Timeline</h3>
                <NTimeline>
                  <NTimelineItem content="Oops" />
                </NTimeline>
                <h3>Thing</h3>
                <NThing title="NThing" />
                <h3>Collapse</h3>
                <NCollapse default-expanded-names="1" accordion>
                  <NCollapseItem title="NCollapseItem1" name="1">
                    NCollapseItem1
                  </NCollapseItem>
                  <NCollapseItem title="NCollapseItem2" name="2">
                    NCollapseItem2
                  </NCollapseItem>
                </NCollapse>
                <h3>Upload</h3>
                <NUpload><NButton>Upload</NButton></NUpload>
                <NUpload><NUploadDragger>NUploadDragger</NUploadDragger></NUpload>
                <h3>Image</h3>
                <NImage
                  width="100"
                  src="https://07akioni.oss-cn-beijing.aliyuncs.com/07akioni.jpeg"
                />
                <h3>Input Group</h3>
                <NInputGroup>
                  <NInput />
                  <NInputGroupLabel>NInputGroupLabel</NInputGroupLabel>
                </NInputGroup>
                <h3>Row & Col</h3>
                <NRow>
                  <NCol span="24">
                    NRow + NCol
                  </NCol>
                </NRow>
                <h3>Log</h3>
                <NLog :lines="['NLog1', 'NLog2']" />
                <h3>Countdown</h3>
                <NCountdown :duration="996" :precision="3" />
                <h3>Number Animation</h3>
                <NNumberAnimation :from="996" :to="99" />
                <h3>Statistic</h3>
                <NStatistic label="NStatistic" value="NStatistic" />
                <h3>Table</h3>
                <NTable>
                  <thead>
                    <tr>
                      <th>NTable</th>
                      <th>NTable</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr>
                      <td>NTable</td>
                      <td>NTable</td>
                    </tr>
                  </tbody>
                </NTable>
                <h3>Tabs</h3>
                <NTabs>
                  <NTabPane name="NTabPane1" tab="NTabPane1">
                    NTabPane1
                  </NTabPane>
                  <NTabPane name="NTabPane2" tab="NTabPane2">
                    NTabPane2
                  </NTabPane>
                </NTabs>
                <h3>Card</h3>
                <NCard title="NCard" />
                <h3>Dialog</h3>
                <NDialog title="NDialog" />
                <h3>Layout</h3>
                <NLayout has-sider>
                  <NLayoutSider>NLayoutSider</NLayoutSider>
                  <NLayoutContent>
                    <NLayoutHeader>NLayoutHeader</NLayoutHeader>
                    NLayoutContent
                    <NLayoutFooter>NLayoutFooter</NLayoutFooter>
                  </NLayoutContent>
                </NLayout>
                <h3>Skeleton</h3>
                <NSkeleton height="40px" width="33%" />
                <h3 class="flex items-center gap-2">
                  Modal
                  <NSwitch v-model:value="showModal" />
                </h3>
                <NModal v-model:show="showModal" preset="card" title="NModal" />
                <h3 class="flex items-center gap-2">
                  Drawer
                  <NSwitch v-model:value="showDrawer" />
                </h3>
                <NDrawer v-model:show="showDrawer">
                  NDrawer
                </NDrawer>
                <h3>Radio</h3>
                <NRadio name="NRadio" label="NRadio" />
                <h3>Radio Group</h3>
                <NRadioGroup name="NRadioGroup">
                  <NRadio value="NRadioGroup1" label="NRadioGroup1" />
                  <NRadio value="NRadioGroup2" label="NRadioGroup2" />
                </NRadioGroup>
                <NRadioGroup name="NRadioButtonGroup">
                  <NRadioButton value="NRadioGroup1" label="NRadioGroup1" />
                  <NRadioButton value="NRadioGroup2" label="NRadioGroup2" />
                </NRadioGroup>
                <h3>Carousel</h3>
                <NCarousel autoplay>
                  <NCarouselItem>
                    <img
                      class="carousel-img"
                      src="https://naive-ui.oss-cn-beijing.aliyuncs.com/carousel-img/carousel1.jpeg"
                    />
                  </NCarouselItem>
                  <NCarouselItem>
                    <img
                      class="carousel-img"
                      src="https://naive-ui.oss-cn-beijing.aliyuncs.com/carousel-img/carousel2.jpeg"
                    />
                  </NCarouselItem>
                </NCarousel>
                <h3>Descriptions</h3>
                <NDescriptions label-placement="top" title="NDescription Title">
                  <NDescriptionsItem>
                    <template #label>
                      NDescriptionsItem1
                    </template>
                    NDescriptionsItem1
                  </NDescriptionsItem>
                  <NDescriptionsItem label="NDescriptionsItem2">
                    NDescriptionsItem2
                  </NDescriptionsItem>
                  <NDescriptionsItem label="NDescriptionsItem3">
                    NDescriptionsItem3
                  </NDescriptionsItem>
                </NDescriptions>
                <h3 class="flex items-center gap-2">
                  Collapse transition
                  <NSwitch v-model:value="showCollapseTransition" />
                </h3>
                <NCollapseTransition v-model:show="showCollapseTransition">
                  NCollapseTransition<br />
                  NCollapseTransition<br />
                  NCollapseTransition
                </NCollapseTransition>
                <h3>Form</h3>
                <NForm>
                  <NFormItem label="FormItem">
                    <NInput />
                  </NFormItem>
                  <NFormItemRow>
                    <NFormItemCol label="NFormItemCol" span="12">
                      <NInput />
                    </NFormItemCol>
                  </NFormItemRow>
                  <NGrid :cols="4">
                    <NFormItemGi label="NFormItemGi">
                      <NInput />
                    </NFormItemGi>
                    <NFormItemGridItem label="NFormItemGridItem">
                      <NInput />
                    </NFormItemGridItem>
                    <NGi>
                      NGi
                    </NGi>
                    <NGridItem>
                      NGridItem
                    </NGridItem>
                  </NGrid>
                </NForm>
                <h3>Steps</h3>
                <NSteps :current="2">
                  <NStep title="NStep1" description="Step 1" />
                  <NStep title="NStep2" description="Step 2" />
                  <NStep title="NStep3" description="Step 3" />
                </NSteps>
                <h3>Scrollbar</h3>
                <NScrollbar style="height: 100px;">
                  NScrollbar<br />
                  NScrollbar<br />
                  NScrollbar<br />
                  NScrollbar<br />
                  NScrollbar<br />
                  NScrollbar<br />
                  NScrollbar<br />
                  NScrollbar<br />
                  NScrollbar<br />
                  NScrollbar<br />
                </NScrollbar>
                <h3>Avatar</h3>
                <NAvatar
                  round
                  size="medium"
                  src="https://07akioni.oss-cn-beijing.aliyuncs.com/07akioni.jpeg"
                />
                <h3>Avatar Group</h3>
                <NAvatarGroup
                  :options="[
                    {
                      src: 'https://gw.alipayobjects.com/zos/antfincdn/aPkFc8Sj7n/method-draw-image.svg',
                    },
                    {
                      src: 'https://07akioni.oss-cn-beijing.aliyuncs.com/07akioni.jpeg',
                    },
                    {
                      src: 'https://gw.alipayobjects.com/zos/antfincdn/aPkFc8Sj7n/method-draw-image.svg',
                    },
                  ]"
                  :size="40"
                  :max="2"
                />
                <h3>Data Table</h3>
                <NDataTable
                  :columns="[
                    { key: 'label', title: 'Label' },
                    { key: 'labelX', title: 'LabelX' },
                  ]"
                  :data="selectOptions"
                />
                <h3>Image Group</h3>
                <NImageGroup>
                  <NImage
                    width="100"
                    src="https://07akioni.oss-cn-beijing.aliyuncs.com/07akioni.jpeg"
                  />
                  <NImage
                    width="100"
                    src="https://gw.alipayobjects.com/zos/antfincdn/aPkFc8Sj7n/method-draw-image.svg"
                  />
                </NImageGroup>
                <h3>Transfer</h3>
                <NTransfer :options="selectOptions" />
                <h3>Anchor</h3>
                <NAnchor ignore-gap>
                  <NAnchorLink title="NAnchorLink NP" href="#NP" />
                  <NAnchorLink title="NAnchorLink NH1" href="#NH1" />
                </NAnchor>
                <h3>Watermark</h3>
                <NWatermark
                  content="Watermark"
                  cross
                  selectable
                  :font-size="16"
                  :line-height="16"
                  :width="192"
                  :height="128"
                  :x-offset="12"
                  :y-offset="28"
                  :rotate="-15"
                >
                  <div class="h-200px w-full flex items-center justify-center">
                    Watermark
                  </div>
                </NWatermark>
                <h3>Back Top</h3>
                <NBackTop :visibility-height="500">
                  <div class="p-4">
                    BackTop
                  </div>
                </NBackTop>
              </NSpace>
            </NDialogProvider>
          </NLoadingBarProvider>
        </NNotificationProvider>
      </NMessageProvider>
    </NConfigProvider>
  </div>
</template>

<style scoped>
h3 {
  --uno: "py-2 text-xl font-bold";
}
</style>
